/* This file is part of the KDE libraries
    Copyright (C) 2009 Norbert Frese <nf2.email@gmail.com>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
 */

#ifndef KSTORAGEIFACE_H_
#define KSTORAGEIFACE_H_

#include <kdiskfreespaceinfo.h>
#include <QtCore/QList>
#include <QtCore/QString>
#include <QtCore/QObject>

class KStorageIface : public QObject
{
    Q_OBJECT

public:
    KStorageIface();

    virtual ~KStorageIface();

    /////

    virtual bool isValid() const = 0;

    virtual QString id() const = 0;

    virtual QString displayName() const = 0;

    virtual QString icon() const = 0;

    virtual QStringList emblems() const = 0;

    virtual QUrl url() const = 0;

    virtual QString mountPointPath() const = 0;

    virtual bool isRemovable() const = 0;

    virtual bool isReleasable() const = 0;

    virtual bool isHotpluggable() const = 0;

    virtual bool isAccessible() const = 0;

    ///// actions ////

    virtual void setup(QObject * doneSignalTarget, const char * doneQSlot) = 0;

    virtual void tearDown(QObject * doneSignalTarget, const char * doneQSlot) = 0;

    virtual void eject(QObject * doneSignalTarget, const char * doneQSlot) = 0;

    ///// signals ////

Q_SIGNALS:

    void changed();

    void removed();

};

#endif /* KSTORAGEIFACE_H_ */
